////////////////////////////////////////////////////////
// Project  : FHS
//
// File     : fhs.h
// Purpose  : 
// Author   : Damir Krstinic
// Copyright: (c) Damir Krstinic
// Version  : v1.0
////////////////////////////////////////////////////////
#ifndef _FHS_
#define _FHS_

#include <cv.h>
#include <highgui.h>

#define NDEBUG
/*
#ifdef NDEBUG
#undef NDEBUG
#endif
*/

#include <assert.h>

//#define DEBUG_OUT
//#define STD_OUT
//#define TIMES_OUT

#define LUV_CSPACE

// #define KERNEL_NORMAL

#define MARK_EDGES

// FHS parameters
#define RHO  3

#define EPS1 9
#define EPS0 0

#ifndef MIN
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#endif

#ifndef MAX
#define MAX(a, b) (((a) > (b)) ? (a) : (b))
#endif

typedef struct {
    int    cid;      // cluster id
    int    label;    // label
    float  cheight;  // Height of mode
    int    cbin[3];  // Grid max of mode
} cspaceClust;

typedef struct {
  int    label;   // cluster id
  int    i, j;    // sample pixel coordinates
  int    numPix;  // cluster size
  float  luv[3];  // mean luv
} clustStat;

typedef struct {
    int la;
    int lb;
    float w;
} einfo;

typedef struct {
    int memsize;
    int size;
    einfo *edges;
} egraph;

// Adaptive histogram
float *createAHist3D(IplImage *, IplImage **, float, int *);

// BOTTOM - UP labeling
int assignLabels3DBU(float *hist, int *nbins, int eps1, int eps0);

// Lebeling utils
IplImage *gridLabels2img(IplImage *, float *, IplImage *, \
		    int *, int, int);

// Segmentation to image using mean segment color
int seg2img(IplImage *srcimg, IplImage *seglabels, int segments);


IplImage *rgb2wcol(IplImage *srcimg);
void mark_edges(IplImage *, IplImage *);

#endif
